<app-loading *ngIf="isLoadingPage"></app-loading>
<form nz-form [formGroup]="form" (keyup.enter)="submitSearch()">
  <div nz-row [nzGutter]="[30,30]">
    <!--    Form tìm kiếm -->
    <!-- Mã nhân viên -->
    <div nz-col [nzXs]="24" [nzLg]="12">
      <mb-input-text formControlName="employeeCode" [mbMaxLength]="200"
                     mbPlaceholderText="{{'staffManager.label.staffCode' | translate}}"
                     mbLabelText="{{'staffManager.label.staffCode' | translate}}"></mb-input-text>
    </div>

    <!-- Tên nhân viên -->
    <div nz-col [nzXs]="24" [nzLg]="12">
      <mb-input-text formControlName="fullName" [mbMaxLength]="200"
                     mbPlaceholderText="{{'staffManager.label.employeeName' | translate}}"
                     mbLabelText="{{'staffManager.label.employeeName' | translate}}"></mb-input-text>
    </div>

    <!-- Trạng thái -->
    <div nz-col [nzXs]="24" [nzLg]="12">
      <mb-select-check-able
        mbPlaceholder="{{'staffManager.label.status' | translate }}"
        [mbDataSelects]="statusList"
        mbLabelText="{{'staffManager.label.status' | translate}}"
        (mbEventEmit)="setFormValue($event, 'listStatus')"
        formControlName="listStatus"></mb-select-check-able>
    </div>

    <!-- Đơn vị -->
    <div nz-col [nzXs]="24" [nzLg]="12">
      <org-data-picker formControlName="organizationId"
                       [scope]="scope"
                       [functionCode]="functionCode"
                       mbLabelText="{{'staffManager.workHisInformation.label.attributes.organization' | translate}}">
      </org-data-picker>
    </div>

    <!-- Đối tượng -->
    <div nz-col [nzXs]="24" [nzLg]="12">
      <mb-select-check-able
        [mbKeyValueStringType]="true"
        mbPlaceholder="{{'staffManager.label.employeeType' | translate}}"
        [mbDataSelects]="listEmpTypeCode"
        mbLabelText="{{'staffManager.label.employeeType' | translate}}"
        (mbEventEmit)="setFormValue($event, 'listEmpTypeCode')"
        formControlName="listEmpTypeCode"></mb-select-check-able>
    </div>

    <!-- Chức danh -->
    <div nz-col [nzXs]="24" [nzLg]="12">
      <mb-select-check-able
        [mbKeyValueStringType]="true"
        mbPlaceholder="{{'staffManager.label.positionName' | translate}}"
        [mbDataSelects]="listPosition"
        mbLabelText="{{'staffManager.label.positionName' | translate}}"
        (mbEventEmit)="setFormValue($event, 'listPositionId')"
        formControlName="listPositionId"></mb-select-check-able>
    </div>
    <!--    End Form tìm kiếm-->


    <div nz-col [nzXs]="24" class="form__search" [nzLg]="12" *ngFor="let item of formConfig">
      <ng-container [ngSwitch]="item.inputType">
        <mb-input-text *ngSwitchCase="'text'" [mbMaxLength]="200"
                       mbPlaceholderText=" {{ item.inputPlaceholder ?? item.inputLabel }} "
                       [mbLabelText]="item.inputLabel" [formControlName]="item.code"
        ></mb-input-text>

        <ng-container *ngSwitchCase="'number'" [ngSwitch]="item.code">
          <mb-numberic-range-input *jrSwitchCases='["listYearOfBirth","listIssueYear", "listYear"]'
                                   [maxNumOfMax]="3000" [maxNumOfMin]="1900"
                                   [mbType]="form.controls[item.code].errors ? 'error' : 'default'"
                                   [mbShowError]="form.controls[item.code].errors !== null"
                                   [mbErrors]="form.controls[item.code].errors"
                                   [mbErrorDefs]="[
           { errorName: item.code, errorDescription: 'staffManager.validate.rangeDate.pareDate' | translate:
            {'fromDate': 'staffManager.table.fromYear' | translate, 'toDate': 'staffManager.table.toYear' | translate}}
           ]"
                                   [mbLabelText]="item.inputLabel"
                                   [formControlName]="item.code"
                                   (ngModelChange)="validateDateNumber($event, item.code)"
          ></mb-numberic-range-input>

          <mb-numberic-range-input *jrSwitchCases='["listMonthOfBirth", "listMonthDependent"]'
                                   [maxNumOfMax]="12" [maxNumOfMin]="1"
                                   [mbType]="form.controls[item.code].errors ? 'error' : 'default'"
                                   [mbShowError]="form.controls[item.code].errors !== null"
                                   [mbErrors]="form.controls[item.code].errors"
                                   [mbErrorDefs]="[
           { errorName: item.code, errorDescription: 'staffManager.validate.rangeDate.pareDate' | translate:
            {'fromDate': 'staffManager.table.fromMonth' | translate, 'toDate': 'staffManager.table.toMonth' | translate}}
           ]"
                                   [mbLabelText]="item.inputLabel"
                                   [formControlName]="item.code"
                                   (ngModelChange)="validateDateNumber($event, item.code)"
          ></mb-numberic-range-input>

          <mb-numberic-range-input *jrSwitchCases='["date", "day"]'
                                   [maxNumOfMax]="31" [maxNumOfMin]="1"
                                   [mbType]="form.controls[item.code].errors ? 'error' : 'default'"
                                   [mbShowError]="form.controls[item.code].errors !== null"
                                   [mbErrors]="form.controls[item.code].errors"
                                   [mbErrorDefs]="[
           { errorName: item.code, errorDescription: 'staffManager.validate.rangeDate.pareDate' | translate:
            {'fromDate': 'staffManager.table.fromDate' | translate, 'toDate': 'staffManager.table.toDate' | translate}}
           ]"
                                   [mbLabelText]="item.inputLabel"
                                   [formControlName]="item.code"
                                   (ngModelChange)="validateDateNumber($event, item.code)"
          ></mb-numberic-range-input>

          <mb-numberic-range-input *ngSwitchDefault
                                   [mbType]="form.controls[item.code].errors ? 'error' : 'default'"
                                   [mbShowError]="form.controls[item.code].errors !== null"
                                   [mbErrors]="form.controls[item.code].errors"
                                   [mbErrorDefs]="[
           { errorName: item.code, errorDescription: 'staffManager.validate.rangeDate.pareDate' | translate:
            {'fromDate': 'staffManager.table.fromDate' | translate, 'toDate': 'staffManager.table.toDate' | translate}}
           ]"
                                   [mbLabelText]="item.inputLabel"
                                   [formControlName]="item.code"
                                   (ngModelChange)="validateDateNumber($event, item.code)"
          ></mb-numberic-range-input>

        </ng-container>

        <mb-select *jrSwitchCases="['combobox', 'radiobox']"
                   [mbKeyValueStringType]="true"
                   mbPlaceholder=" {{ item.inputPlaceholder ?? item.inputLabel }} "
                   [mbDataSelects]="item.dataSource"
                   [mbIsLoading]="item.loadingDataSource"
                   [mbLabelText]="item.inputLabel" [formControlName]="item.code"
        ></mb-select>

        <mb-select-check-able *jrSwitchCases="['multi-combobox', 'checkbox']"
                              [mbKeyValueStringType]="true"
                              mbPlaceholder=" {{ item.inputPlaceholder ?? item.inputLabel }} "
                              [mbDataSelects]="item.dataSource"
                              [mbIsLoading]="item.loadingDataSource"
                              (mbEventEmit)="setFormValue($event, item.code)"
                              [mbLabelText]="item.inputLabel" [formControlName]="item.code"
        ></mb-select-check-able>

        <mb-rang-date-picker *ngSwitchCase="'date'"
                             [mbType]="form.controls[item.code].errors ? 'error' : 'default'"
                             [mbShowError]="form.controls[item.code].errors !== null"
                             [mbErrors]="form.controls[item.code].errors"
                             [mbErrorDefs]="[
                            { errorName: item.code, errorDescription: 'staffManager.validate.rangeDate.pareDate' | translate:
                            {'fromDate': 'staffManager.table.fromDate' | translate, 'toDate': 'staffManager.table.toDate' | translate}}
                            ]"
                             [mbLabelText]="item.inputLabel"
                             [formControlName]="item.code"
                             (ngModelChange)="validateDate($event, item.code)"
        ></mb-rang-date-picker>
      </ng-container>

    </div>
  </div>


  <!-- Thêm điều kiện tìm kiếm -->
  <div nz-row [nzGutter]="[30,30]">
    <div nz-col [nzXs]="24" [nzLg]="12" style="display: flex">
      <mb-select-check-able
        [mbDataSelects]="listExtendField"
        (mbEventEmit)="doAddOrRemoveFieldExtend($event)"
        mbKeyLabel="inputLabel"
        mbKeyValue="code"
        mbPlaceholder="{{'staffManager.label.addSearchCondition' | translate}}"
        formControlName="extendField"
        style="width: -webkit-fill-available"
      ></mb-select-check-able>
      <mb-button class="btn-choose__bookmark " mbButtonIconType="AWESOME" mbPrefixIcon="fas fa-star"
                 mbButtonSize="VERY_LARGE"
                 mbButtonTextColor="#7F85F3"
                 nz-popover
                 nzPopoverTrigger="click"
                 [nzPopoverTitle]="null"
                 [(nzPopoverVisible)]="chooseBookmarkVisible"
                 [nzPopoverContent]="chooseBookmarkTmpl"
                 nzPopoverPlacement="leftBottom"
                 mbButtonBgColor="#FFFFFF"></mb-button>
      <mb-button class="btn-save__bookmark" mbButtonIconType="AWESOME" mbPrefixIcon="fas fa-bookmark"
                 mbButtonSize="VERY_LARGE"
                 mbButtonTextColor="#7F85F3"
                 nz-popover
                 [(nzPopoverVisible)]="saveBookmarkVisible"
                 nzPopoverTrigger="click"
                 [nzPopoverTitle]="null"
                 [nzPopoverContent]="saveBookmarkTmpl"
                 nzPopoverPlacement="rightBottom"
                 mbButtonBgColor="#FFFFFF"></mb-button>
    </div>
    <div nz-col [nzXs]="24" [nzLg]="12"></div>
  </div>

</form>


<ng-template #saveBookmarkTmpl>
  <div class="popover__inner">
    <p><strong>{{'staffManager.label.saveSearchCondition' | translate}}</strong></p>
    <mb-input-text [mbMaxLength]="200"
                   [mbShowFlexEnd]="false"
                   mbPlaceholderText=" {{'staffManager.label.saveName' | translate}}  "
                   [(ngModel)]="saveBookmarkName"></mb-input-text>
  </div>
  <div class="popover_footer">
    <mb-button mbButtonSize="LARGE" mbButtonAvailableStyle="PRIMARY"
               mbButtonText="{{'staffManager.label.saveCurrentRecord' | translate}}"
               *ngIf="choosedBookmarkId"
               (click)="choosedBookmarkId ? saveBookmark(choosedBookmarkId) : $event.stopPropagation()"
               class="btn__save"></mb-button>
    <mb-button mbButtonSize="LARGE" mbButtonAvailableStyle="PRIMARY"
               mbButtonText="{{'staffManager.label.addRecord' | translate}}"
               (click)="saveBookmarkName ? saveBookmark(): $event.stopPropagation()" class="btn__save"></mb-button>
  </div>
</ng-template>
<ng-template #chooseBookmarkTmpl>
  <div class="popover__inner">
    <p><strong>{{'staffManager.label.selectConditionSave' | translate}}</strong></p>
    <mb-select
      mbKeyValue="userBookmarkId"
      mbKeyLabel="name"
      mbPlaceholder="{{'staffManager.label.select' | translate}}"
      [mbDataSelects]="bookmarks" [(ngModel)]="choosedBookmarkId"></mb-select>
  </div>
  <div class="popover_footer">
    <mb-button mbButtonSize="LARGE" mbButtonAvailableStyle="PRIMARY"
               mbButtonText="{{'staffManager.label.selectBookmark' | translate}}"
               (click)="choosedBookmarkId ? chooseBookmark() : $event.stopPropagation()"
               class="btn__choose"></mb-button>
    <mb-button mbButtonSize="LARGE" mbButtonAvailableStyle="DANGER"
               mbButtonText="{{'staffManager.label.deleteBookmark' | translate}}"
               (click)="choosedBookmarkId ? deleteBookmark() : $event.stopPropagation()"
               class="btn__choose"></mb-button>
  </div>
</ng-template>
